

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;


function scAutoCompleteSearchProxy() {
}


scAutoCompleteSearchProxy.prototype = {
	classDescription: "scAutoCompleteSearchProxySvc JS component",
	classID:          Components.ID("{64896643-3859-4BDA-997E-5718725CE2A2}"),
	contractID:       "@mozilla.org/autocomplete/search;1?name=scProxy",
		
		
	fProviders : {},
	fCounter : 1,
	fLastProviderCalled : null,
	
	/* */
    startSearch: function(pSearchString, pSearchParam, pPreviousResult, pListener) {
    	if(pSearchParam) {
    		var vIdx = pSearchParam.indexOf(":");
    		var vIdProvider = vIdx > 0 ? pSearchParam.substring(0, vIdx) : pSearchParam;
    		this.fLastProviderCalled = this.fProviders[vIdProvider];
    		if(this.fLastProviderCalled) {
    			this.fLastProviderCalled.startSearch(pSearchString, vIdx > 0 ? pSearchParam.substring(vIdx+1) : null, pPreviousResult, pListener);
    			return;
    		}
    	}

    	pListener.onSearchResult(this, {
            QueryInterface: function(pIID) {
              if (pIID.equals(Ci.nsIAutoCompleteResult) || pIID.equals(Ci.nsISupports))
                return this;
              throw Components.results.NS_NOINTERFACE;
            },
            results: [],
            defaultIndex: 0,
            errorDescription: null,
            matchCount: 0,
            searchResult: Ci.nsIAutoCompleteResult.RESULT_SUCCESS,
            searchString: pSearchString,
            getCommentAt: function(pIndex) {return null;},
            getImageAt: function(pIndex) {return null;},
            getStyleAt: function(pIndex) {return null;},
            getValueAt: function(pIndex) {return null;},
            getLabelAt: function(index) {return null;},
            removeValueAt: function(pRowIndex, pRemoveFromDb) {}
         });
    	
    },
    
    /* */
    stopSearch: function() {
    	if(this.fLastProviderCalled) this.fLastProviderCalled.stopSearch();
    },
    
    registerProvider: function(pProvider) {
    	if(pProvider == null) return;
    	var vId = "a" + (this.fCounter++);
    	this.fProviders[vId] = pProvider;
    	return vId;
    },
    
    unregisterProvider: function(pIdProvider) {
    	if(pIdProvider == null) return;
    	delete this.fProviders[pIdProvider];
    },
    
    QueryInterface: XPCOMUtils.generateQI([Ci.scIAutoCompleteSearchProxy,
                                           Ci.nsIAutoCompleteSearch,
                                           Ci.nsISupports])
}



function debug(pText){
	var vConsoleService = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}


var NSGetFactory = XPCOMUtils.generateNSGetFactory([scAutoCompleteSearchProxy]);

